#include <cstdio>
using namespace std;

typedef long long int64_t;
int64_t mod;

int64_t qpow(int64_t a,int64_t b)
{
    int64_t ans=1;
    for(;b;b>>=1)
    {
        if(b&1)
            ans=ans*a%mod;
        a=a*a%mod;
    }
    return ans;
}

int main()
{
    int T;
    scanf("%d",&T);
    for(int t=1;t<=T;t++)
    {
        int64_t n,k,x,sum=0;
        scanf("%lld%lld%lld",&n,&k,&mod);
        for(int64_t i=0;i<n;i++)
            scanf("%lld",&x),sum+=x;
        printf("Case %d: %lld\n",t,(sum%mod)*qpow(n,k-1)*k%mod);
    }
    return 0;
}
